#ifndef __wxBurn_DnD__
#define __wxBurn_DnD__

#ifdef __GNUG__
    #pragma interface "wxBurn.h"
#endif

// Include wxWindows' headers

#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif

#include <wx/dnd.h>
#include <wx/dirctrl.h>
#include <wx/listctrl.h>
#include <wx/dir.h>

#include "CDLayoutTreeCtrl.h"

//----------------------------------------------------------------------------
// TreeDnDFile
//----------------------------------------------------------------------------
class TreeDnDFile : public wxFileDropTarget
{
public:
  TreeDnDFile(CDLayoutTreeCtrl* pOwner, wxListCtrl* pListCtrl) { m_pOwner = pOwner; m_pListCtrl = pListCtrl; }

  virtual bool OnDropFiles(wxCoord x, wxCoord y, const wxArrayString& filenames);

private:
  CDLayoutTreeCtrl *m_pOwner;
  wxListCtrl *m_pListCtrl;
};

//----------------------------------------------------------------------------
// ListDnDFile
//----------------------------------------------------------------------------
class ListDnDFile : public wxFileDropTarget
{
public:
  ListDnDFile(CDLayoutTreeCtrl *pNavTree, wxListCtrl *pOwner) { m_pNavTree = pNavTree; m_pOwner = pOwner; }

  virtual bool OnDropFiles(wxCoord x, wxCoord y, const wxArrayString& filenames);

private:
  CDLayoutTreeCtrl *m_pNavTree;
  wxListCtrl *m_pOwner;
};

//----------------------------------------------------------------------------
// BurnerAvailFilesTraverser
//----------------------------------------------------------------------------
class BurnerAvailFilesTraverser : public wxDirTraverser
{
public:
  BurnerAvailFilesTraverser(wxListCtrl* pListCtrl) { m_pAvailFilesListCtrl = pListCtrl; }

  virtual wxDirTraverseResult OnFile(const wxString& filename);
  virtual wxDirTraverseResult OnDir(const wxString& dirname);

protected:
  wxListCtrl* m_pAvailFilesListCtrl;
};

#endif // __wxBurn_DnD__
